from pandas import DataFrame, merge, read_pickle
from offline_results.common.read_write_from_s3 import ConnectS3
from offline_results.common.config import FILENAME_VIDEO_MEASURE, VISIONPLUS_DEV, USER_PREFERENCES_PATH, \
    RAW_DATA_PATH, UBD_DATA_PATH, HOMEPAGE_HAVING_CONTENT_PATH, HAS_ATTRIBUTE1_PREFERENCE, HAS_CATEGORY_PREFERENCE, \
    HAS_SUBCATEGORY_PREFERENCE
from offline_results.common.constants import CSV_EXTENSION, TAGS, SUBCATEGORY, CATEGORY, HOMEPAGE_HAVING_CONTENT, \
    HOME_PAGE_HAVING_CONTENT, CUSTOMER_ID, UBD, USER_PREFERENCES, S3, GRAPH_DB, HOMEPAGE_ID, TOD, DURATION, \
    GZIP_EXTENSION, ATTRIBUTE1, CATEGORY_ID, SUBCATEGORY_ID, HAS_TAG_PREFERENCE, HAS_TOD_PREFERENCE, \
    HAS_DURATION_PREFERENCE, TAGS_ID, VALUE, CONTENT_DURATION
import functools as ft
import logging
from sklearn.preprocessing import OneHotEncoder
from pandas import read_csv

from offline_results.recommendation.utils import RecommendationUtils

logging.basicConfig(level=logging.INFO)

class DataGathering(RecommendationUtils):

    def __init__(
            self,
    ):
        self.ubd = DataFrame()
        self.homepage_having_content = DataFrame()
        self.category_pref = DataFrame()
        self.sub_category_pref = DataFrame()
        self.tags_pref = DataFrame()
        self.preferences = DataFrame()
        self.duration_pref = DataFrame()
        self.tod_pref = DataFrame()


    def data_gathering(
            self,
            is_paytv
    ):
        self.tags_pref = self.user_pref(TAGS, HAS_TAG_PREFERENCE, is_paytv, [TAGS_ID, CUSTOMER_ID])
        self.duration_pref = self.user_pref(CONTENT_DURATION, HAS_DURATION_PREFERENCE, is_paytv, [VALUE, CUSTOMER_ID])
        self.category_pref = self.user_pref(CATEGORY, HAS_CATEGORY_PREFERENCE, is_paytv, [CATEGORY_ID, CUSTOMER_ID])
        self.sub_category_pref = self.user_pref(SUBCATEGORY, HAS_SUBCATEGORY_PREFERENCE, is_paytv, [SUBCATEGORY_ID, CUSTOMER_ID])
        self.tod_pref = self.user_pref(TOD, HAS_TOD_PREFERENCE, is_paytv, [VALUE, CUSTOMER_ID])
        self.duration_pref.columns = [DURATION, CUSTOMER_ID]
        self.homepage_having_content = self.content_having_homepage(is_paytv)

        ctl = ConnectS3()
        resource = ctl.create_connection()
        self.ubd = ctl.read_compress_pickles_from_S3(VISIONPLUS_DEV, UBD_DATA_PATH, resource)


##test code here
# if __name__ =="__main__":
#     ctl= DataGathering()
#     ctl.data_gathering(True)
