from offline_results.recommendation.homepage_cluster_category.hompage_id_recommendation.data_gathering import \
    DataGathering
from offline_results.recommendation.homepage_cluster_category.hompage_id_recommendation.data_preperation import \
    DataPreprocessing
from offline_results.recommendation.homepage_cluster_category.hompage_id_recommendation.model_training import \
    ClassificationModel

from pandas import DataFrame, Series
from offline_results.common.constants import HOMEPAGE_ID, S3
import logging
logging.basicConfig(level=logging.INFO)


class HomepageCatRecommendation(DataGathering, DataPreprocessing):

    def __init__(self, is_paytv=True):
        self.data = {}
        self.dataset = DataFrame
        self.is_paytv = is_paytv

    def get_data(self, is_paytv):
        self.data_gathering(is_paytv)

    def preprocess_data(self):
        self.data_preprocessing()

    def model_training(self):
        self.get_data(self.is_paytv)
        self.preprocess_data()
        target = self.ubd[HOMEPAGE_ID].apply(Series).to_numpy()
        features = self.ubd.drop(columns=HOMEPAGE_ID).to_numpy()
        ctl = ClassificationModel(features, target)
        model = ctl.evaluate_model()
        ctl.save_model_to_s3(model, self.is_paytv)



# #test code here
# if __name__ == "__main__":
#     ctl=HomepageCatRecommendation()
#     ctl.model_training()
