import logging
from pandas import DataFrame
from offline_results.common.constants import  CONTENT_ID, VIEW_COUNT, SCORE


class CFItemtoItem:


    def most_viwed_content(
            self,
            df: DataFrame
    ):
        try:
            df = df.groupby([CONTENT_ID])[VIEW_COUNT].sum().reset_index()
            df = df[df[VIEW_COUNT] == df[VIEW_COUNT].max()].reset_index(drop=True)
            most_viewed_content = df.iloc[0][CONTENT_ID]
            return most_viewed_content
        except Exception as e:
            logging.error(f"error while calling most_vied_content, Error {e}")

    def similar_contents(
            self,
            content_id,
            content_similarity
    ):
        data = content_similarity.get(content_id, {})
        if len(data) == 0: return DataFrame(columns=[CONTENT_ID, SCORE])
        data = DataFrame({CONTENT_ID: data.keys(), SCORE: data.values()}, columns=[CONTENT_ID, SCORE])
        return data

    def generate_rec(
            self,
            ubd,
            content_similarity,
            content_list,
    ):
        if len(ubd) == 0 or len(content_list) == 0:
            return DataFrame(columns=[CONTENT_ID, SCORE])
        most_viewed_content_id = self.most_viwed_content(ubd)
        result = self.similar_contents(most_viewed_content_id, content_similarity)
        result = result[result[CONTENT_ID].isin(content_list)]
        return result

