import pandas as pd

from offline_results.common.config import BUCKET_NAME, cluster_pkl_path_file
from offline_results.updater.preference_updater import PreferenceUpdater
from offline_results.updater.prepare_ubd import UserMap
from offline_results.updater.user_cluster_updater import ClusterUpdater
from offline_results.updater.user_node_updater import NodeUpdater


class UpdaterMain:

    @staticmethod
    def vdb_updater(redis_uri):
        """
        Driver function to call vdb updater network
        :param redis_uri: redis connection uri
        """
        NodeUpdater.vdb_updater(bucket_name=BUCKET_NAME, object_name=cluster_pkl_path_file, redis_uri=redis_uri)

    @staticmethod
    def ubd_updater(redis_uri):
        """
        Driver function to call ubd updater network
        :param redis_uri: redis connection uri
        """
        preference = PreferenceUpdater()
        ubd = UserMap.mapping_ubd()
        merged_preferences = preference.controller(ubd)
        cluster_updater = ClusterUpdater()
        cluster_updater.controller(
            data=merged_preferences, bucket_name=BUCKET_NAME, object_name=cluster_pkl_path_file, redis_uri=redis_uri
        )
